################################################################
# Summon a hitbox consisting of an interaction entity and a data
# marker riding said interaction.
#
# API provides the new data marker to work with!
#
# Provided args can be accessed directly as macros or using the
# the storage uf_entity.hitbox under the path "summon.input". 
#
#
# @as = marker[DM]
# @at = nd
# @args = {
#   height: float
#   width: float
#   on_attack: string[function]
#   on_interact: string[function]
#   owner_UUID: string[UUID]
# }
################################################################


# Set marker's tags
tag @s add UF_ENTITY
tag @s add UF_ENTITY.DM
tag @s add UF_ENTITY.DM-hitbox

# Set marker's data
data modify entity @s data.on_attack set from storage uf_entity:hitbox summon.input.on_attack
data modify entity @s data.on_interact set from storage uf_entity:hitbox summon.input.on_interact
data modify entity @s data.owner_UUID set from storage uf_entity:hitbox summon.input.owner_UUID

# Summon and ride the interaction
$summon minecraft:interaction ~ ~ ~ {height:$(height), width:$(width), Tags:["UF_ENTITY", "UF_ENTITY.hitbox", "UF_ENTITY.hitbox.on_interact", "UF_ENTITY.hitbox.on_attack"]}
ride @s mount @n[type=minecraft:interaction, tag=UF_ENTITY.hitbox, predicate=!uf_api:.entity/.has/data_marker]


#-------------------------- EPILOGUE --------------------------#
function uf_api:.data/.math/uuid
data modify storage uf_entity:hitbox summon.output.DM_UUID set from storage uf_data:math.uuid output
#--------------------------------------------------------------#